/*
 * Esercizio 1 (lezione del 12/03/10)
 * Ordinare una sequenza di stringhe mediante Selection Sort
 * 
 */

#include <stdio.h>
#include <stdlib.h>

#define MAXLEN 100

/*
 * Funzione char **leggi(int *N):
 * Lettura delle stringhe da standard input. La prima linea è un intero N pari al numero numero di stringhe da ordinare. 
 * Le N linee successive contengono le stringhe da ordinare, ciascuna delle quali lunga al più MAXLEN caratteri. 
 * La funzione restituisce un array char* stringhe[], i cui elementi sono puntatori alle stringhe in input, e scrive 
 * il numero di stringhe lette nell'intero passato per riferimento.
 */

char **leggi(int *N)
{
    int i;
    char **stringhe;

    scanf("%d", N); /* Numero di stringhe */

    stringhe = (char **)malloc(sizeof (char *) * (*N));
    for ( i = 0; i < *N; i++ ) 
    {
      stringhe[i] = (char *)malloc(sizeof(char)*(MAXLEN+1)); 
      scanf("%s", stringhe[i]);
    }

    return stringhe;
}


/*
 * Funzione per confrontare lessicograficamente due stringhe (equivalente alla funzione di libreria 
 *  strcmp): 
 *  ritorna -1, 0, 1 se stringa1 <, =, > stringa2  
 */

int my_strcmp( const char *stringa1, const char *stringa2 ) 
{
   
   /* Confronto lessicografico tra due stringhe. 
    * Se una stringa e' prefisso dell'altra, essa e' minore.
    * Supponendo non siano ne' identiche ne' prefisso, 
    * allora il primo carattere discordante determina l'ordinamento.
    * La procedura sotto è equivalente ad una chiamata alla funzione
    *   strcmp(stringa1, stringa2);
    */

    int i;
    for (i=0;
         stringa1[i] == stringa2[i] && stringa1[i] != '\0'; 
        i++);

    if ( stringa1[i] < stringa2[i] ) 
	return -1;
    else if ( stringa1[i] == stringa2[i] /* == '\0' */)   
	return 0;
    else return 1;
}


void StringSort(char **as, int len){

 int i,j,min;
 char *tmp;

 for (i=0; i<(len-1); i++) {

   min =i;           /* calcola min di as[i,n]*/
   for(j=i+1; j < len; j++){
      if (my_strcmp(as[j], as[min]) < 0)
              min = j;
   }

   tmp = as[i];       /* scambia as[min] e as[i]*/
   as[i] = as[min];
   as[min] = tmp;
 }

}

int main()
{
   int i;
   int N; // Numero di stringhe 

   //  char *stringhe[] = { .... };
   char **stringhe = leggi(&N);
   
   StringSort( stringhe, N);

   for ( i = 0; i < N; i++ ) 
     printf("%s\n", stringhe[i]);
   
   return 0;
}

